<?php ob_start();
include_once(NTZCRM_DIR_PATH . "includes/admin/form-fields.php");


/*Remove admin bar for subscriber*/
add_action('after_setup_theme', 'ntzcrm_remove_admin_bar');

function ntzcrm_remove_admin_bar()
{
  if (!current_user_can('administrator') && !is_admin()) {
    show_admin_bar(false);
  }
}


/*Remove logo at Login / Reset password page*/
add_action('admin_bar_menu', 'ntzcrm_remove_wp_logo', 999);
function ntzcrm_remove_wp_logo($wp_admin_bar)
{
  $wp_admin_bar->remove_node('wp-logo');
}

add_filter('login_headerurl', 'ntzcrmLoginLogoUrl');
function ntzcrmLoginLogoUrl($url)
{
  return home_url();
}

function ntzcrmUserLastLogout($user)
{
  $userId = get_current_user_id();
  ntzcrm_dbquery::_svUserLogOutTime($userId);
}
add_action('wp_logout', 'ntzcrmUserLastLogout', 1);

function ntzcrmRedirectAfterPasswordReset( $lostpassword_redirect ) {
  $redirect=(get_option('ntzcrm_login_url') != false & strlen(get_option('ntzcrm_login_url')) > 0 )? get_option('ntzcrm_login_url'): site_url("/crm-memberships-login");
  wp_safe_redirect($redirect);
  exit; // always exit after wp_safe_redirect
}
add_filter( 'after_password_reset', 'ntzcrmRedirectAfterPasswordReset' );

function ntzcrmUserLastLogin($user_login, $user)
{
  ntzcrm_dbquery::_svUserLoginTime($user->ID);
}
add_action('wp_login', 'ntzcrmUserLastLogin', 10, 2);


function ntzcrmCustomLoginLogo()
{
  echo '<style type="text/css">
    h1 a {width:100%!important; height: 100px!important; background-image:url(' . get_option("ntzcrm_logo") . ') !important; margin:0 auto;}
    </style>';
}
add_filter('login_head', 'ntzcrmCustomLoginLogo');
/*End Logo change at Login/Reset password page */


function ntzcrm_user_tag_permission($user)
{
  $tags = ntzcrm_dbquery::_getMembershipTagsList();
  $userTags = ntzcrm_dbquery::_getUserTagList($user->ID);
  if (!$userTags) {
    $userTags = [];
    $tagids = get_user_meta($user->ID, '_ntzcrm_user_tag_ids', true);
    if (!empty($tagids['ids'])) {
      foreach ($tagids['ids'] as $key => $tid) {
        $userTags[] = $tid;
      }
    }
  }
  include_once NTZCRM_DIR_PATH . "includes/admin/usermeta.php";
}
add_action('show_user_profile', 'ntzcrm_user_tag_permission');
add_action('edit_user_profile', 'ntzcrm_user_tag_permission');
add_action('user_new_form', 'ntzcrm_user_tag_permission');

function ntzcrm_post_tag_permission($user){
  add_meta_box('custom_contact_tag_id', 'CRM Memberships Permission', 'ntzcrm_post_meta', array("post", "page"), 'normal', 'high');
}
add_action('add_meta_boxes', 'ntzcrm_post_tag_permission');

function ntzcrm_post_meta()
{
  include_once NTZCRM_DIR_PATH . "includes/admin/postmeta.php";
}
add_action('personal_options_update', 'ntzcrm_update_profile_fields');
add_action('edit_user_profile_update', 'ntzcrm_update_profile_fields');

function ntzcrm_update_profile_fields($user_id){
  $request=NtzCrmPostPermission::ntzcrmRequests();  
  if (isset($request['ntzcrm_contact_id']) && !empty($request['ntzcrm_contact_id'])) {
    if (!get_user_meta($user_id, 'ntzcrm_contact_id', true)) {
      add_user_meta($user_id, 'ntzcrm_contact_id',trim($request['ntzcrm_contact_id']));
    } else {
      update_user_meta($user_id, 'ntzcrm_contact_id',trim($request['ntzcrm_contact_id']));
    }
  }
  if (isset($request['all_access']) && !empty($request['all_access'])) {
    if (!get_user_meta($user_id, 'all_access', true)) {
      add_user_meta($user_id, 'all_access', trim($request['all_access']));
    } else {
      update_user_meta($user_id, 'all_access',trim($request['all_access']));
    }
  }

  global $wpdb;
  if (isset($request['usertag']) && !empty($request['usertag'])) {
    $tags = array_unique($request['usertag']);
    global $wpdb;
    if (!empty($tags)) {
      $values = [];
      $table_name = $wpdb->prefix . NTZCRMPRIFIX . "user_tags";
      $countTags = ntzcrm_dbquery::_checkUserTag($user_id);
      if ($countTags > 0) {
        $wpdb->delete($table_name, array('user_id' => $user_id));
      }
      foreach ($tags as $key => $tagId) {
        array_push($values, $user_id, $tagId);
        $place_holders[] = "('%d', '%d')";
      }
      $query = "INSERT INTO $table_name (user_id, tag_id) VALUES ";
      $query .= implode(', ', $place_holders);
      $wpdb->query($wpdb->prepare("$query ", $values));
    }
  }
}

function ntzcrm_save_post_tag()
{
  global $wpdb, $post;
  $values = [];
  $request=NtzCrmPostPermission::ntzcrmRequests();
  if (isset($request['is_ntzcrm_publication']) && !empty($request['is_ntzcrm_publication'])) {
    if (!get_post_meta($post->ID, 'is_ntzcrm_publication', true)) {
      add_post_meta($post->ID, 'is_ntzcrm_publication',trim($request['is_ntzcrm_publication']));
    }else{
      update_post_meta($post->ID, 'is_ntzcrm_publication',trim($request['is_ntzcrm_publication']));
    }
  } else {
    if(!empty($post)){   
      if (!get_post_meta($post->ID, 'is_ntzcrm_publication', true)) {
        add_post_meta($post->ID, 'is_ntzcrm_publication', "no");
      }else{
        update_post_meta($post->ID, 'is_ntzcrm_publication', "no");
      }
    }
  }
  // pr($_POST);
  // die;
  if (isset($request['is_fronted_publication']) && !empty($request['is_fronted_publication'])) {
    if (!get_post_meta($post->ID, 'is_fronted_publication', true)) {
      add_post_meta($post->ID, 'is_fronted_publication',trim($request['is_fronted_publication']));
    } else {
      update_post_meta($post->ID, 'is_fronted_publication',trim($request['is_fronted_publication']));
    }
  } else {
    if(!empty($post)){   
      if (!get_post_meta($post->ID, 'is_fronted_publication', true)) {
        add_post_meta($post->ID, 'is_fronted_publication', "no");
      } else {
        update_post_meta($post->ID, 'is_fronted_publication', "no");
      }
    } 
  }

  if (isset($request['is_ntzcrm_login_required']) && !empty($request['is_ntzcrm_login_required'])) {
    if (!get_post_meta($post->ID, 'is_ntzcrm_login_required', true)) {
      add_post_meta($post->ID, 'is_ntzcrm_login_required',trim($request['is_ntzcrm_login_required']));
    } else {
      update_post_meta($post->ID, 'is_ntzcrm_login_required',trim($request['is_ntzcrm_login_required']));
    }
  }
  if (isset($request['ntzcrm_access_icon']) && !empty($request['ntzcrm_access_icon'])) {
    if (!get_post_meta($post->ID, 'ntzcrm_access_icon', true)) {
      add_post_meta($post->ID, 'ntzcrm_access_icon',trim($request['ntzcrm_access_icon']));
    } else {
      update_post_meta($post->ID, 'ntzcrm_access_icon',trim($request['ntzcrm_access_icon']));
    }
  }
  if (isset($request['ntzcrm_noaccess_icon']) && !empty($request['ntzcrm_noaccess_icon'])) {
    if (!get_post_meta($post->ID, 'ntzcrm_noaccess_icon', true)) {
      add_post_meta($post->ID, 'ntzcrm_noaccess_icon',trim($request['ntzcrm_noaccess_icon']));
    } else {
      update_post_meta($post->ID, 'ntzcrm_noaccess_icon',trim($request['ntzcrm_noaccess_icon']));
    }
  }

  if (isset($request['posttag']) && !empty($request['posttag'])) {
    $tags = array_unique($request['posttag']);
    $table_name = $wpdb->prefix . NTZCRMPRIFIX . "post_tags";
    $wpdb->delete($table_name, array('post_id' => $post->ID));
    foreach ($tags as $key => $tagId) {
      array_push($values, $post->ID, $tagId);
      $place_holders[] = "('%d', '%d')";
    }
    $query = "INSERT INTO $table_name (post_id, tag_id) VALUES ";
    $query .= implode(', ', $place_holders);
    $wpdb->query($wpdb->prepare("$query ", $values));
  }
}

add_action('save_post', 'ntzcrm_save_post_tag');


/*
   * @params: 
   * @Function use: _CallSSO: This is common function using for call curl 
   * @created by: Hitesh verma
   * @Created: 27-10-2020
   */
// add_filter('page_template','ntzcrm_dashboard' );
// function ntzcrm_dashboard($page_template ){
//     if (is_page('login') ) { 
//       $page_template = include_once NTZCRM_DIR_PATH.'includes/view/login.php';
//     }
//     return $page_template;
// } 

function ntzcrm_admin_menu($value = '')
{
  if (is_admin() && get_option('is_actived_ntzcrm') == '1') {
    add_menu_page(__('CRM Memberships Settings', 'ntzcrm_membership'), __('CRM Memberships', 'ntzcrm_exale_membership'), 'activate_plugins', 'getting-started', 'ntzcrm_getting_started',NTZCRM_PLUGIN_URL.'images/ntzcrm.png', null);
    add_submenu_page('getting-started', 'Getting Started', 'Getting Started', 'manage_options', 'getting-started', 'ntzcrm_getting_started');
    add_submenu_page('getting-started', 'Settings', 'Settings', 'manage_options', 'ntzcrm-settings', 'ntzcrm_settings');
    add_submenu_page('getting-started', 'Publications', 'Publications', 'manage_options', 'publications', 'ntzcrm_publications');
    add_submenu_page('getting-started', 'Publication  Wizard', 'Publication Wizard', 'manage_options', 'add-publication-wizard', 'ntzcrm_add_publication_wizard');
    add_submenu_page('getting-started', 'Access Tags', 'Access Tags', 'manage_options', 'add-new-tag', 'ntzcrm_add_tag_form');
    add_submenu_page('getting-started', 'Subscribers', 'Subscribers', 'manage_options', 'subscribers', 'ntzcrm_subscribers');
  }
}
add_action('admin_menu', 'ntzcrm_admin_menu');

function ntzcrm_getting_started(){
  include_once(NTZCRM_DIR_PATH . "includes/admin/getting-started.php");
}


function ntzcrm_settings()
{
  include_once(NTZCRM_DIR_PATH . "includes/admin/admin-page.php");
}

function ntzcrm_display_theme_panel_fields(){

  add_settings_field("ntzcrm_logo", "Logo For Login Page", "ntzcrm_logo", "commontheme-options", "section");
  
  add_settings_field("ntzcrm_login_url", "Login page url", "ntzcrm_login_url", "commontheme-options", "section");

  add_settings_field("ntzcrm_log_redirect_url", "Redirect Page URL After Login", "ntzcrm_log_redirect_url", "commontheme-options", "section");
  add_settings_field("ntzcrm_logout_redirect_url", "Redirect Page URL After Logout", "ntzcrm_logout_redirect_url", "commontheme-options", "section");

  add_settings_field("ntzcrm_enable_log", "Enable Logs", "ntzcrm_enable_log", "commontheme-options", "section");
  add_settings_field("ntzcrm_enable_resetpasswored_usercreation", "Reset Password on User Creation ", "ntzcrm_enable_resetpasswored_usercreation", "commontheme-options", "section");
  add_settings_field("ntzcrm_opt_default_navlinks", "Add Publication Menu Item", "ntzcrm_opt_default_navlinks", "commontheme-options", "section");
  add_settings_field("ntzcrm_publ_welcome_title", "Welcome Title", "ntzcrm_publ_welcome_title", "commontheme-options", "section");
  add_settings_field("ntzcrm_publ_welcome_text", "Welcome Text", "ntzcrm_publ_welcome_text", "commontheme-options", "section");
  
  
  add_settings_section("section", "", null, "commontheme-options");
  add_settings_section("section", "", null, "salesforce-settings");
  add_settings_section("section", "", null, "usertracking-options");
  add_settings_section("section", "", null, "emailtemplate-options");

  add_settings_field("ntzcrm_api_key", "Salesforce NTZ CRM API Key <i>(Required)</i>", "ntzcrm_api_key", "salesforce-settings", "section");
  add_settings_field("ntzcrm_api_token", "Salesforce NTZ CRM API Token <i>(Required)</i>", "ntzcrm_api_token", "salesforce-settings", "section");
  
  add_settings_field("ntzcrm_disabled_post_tracking", "Page view tracking", "ntzcrm_disabled_post_tracking", "usertracking-options", "section");

  
  add_settings_field("ntzcrm_resetpassword_mail_template", "Reset Password Template", "ntzcrm_resetpassword_mail_template", "emailtemplate-options", "section");


  register_setting("section", "ntzcrm_enable_log");
  register_setting("section", "ntzcrm_enable_resetpasswored_usercreation");
  register_setting("section", "ntzcrm_logo");
  register_setting("section", "ntzcrm_opt_default_navlinks");
  register_setting("section", "ntzcrm_publ_welcome_title");
  register_setting("section", "ntzcrm_publ_welcome_text");
  register_setting("section", "ntzcrm_api_key");
  register_setting("section", "ntzcrm_api_token");
  register_setting("section", "ntzcrm_service_url");
  register_setting("section", "ntzcrm_login_url");
  register_setting("section", "ntzcrm_log_redirect_url");
  register_setting("section", "ntzcrm_logout_redirect_url");
  register_setting("section", "ntzcrm_disabled_post_tracking");
  register_setting("section", "ntzcrm_resetpassword_mail_template");
}
add_action("admin_init", "ntzcrm_display_theme_panel_fields");

function ntzcrm_subscribers()
{
 
  include_once(NTZCRM_DIR_PATH . "includes/admin/subscribers.php");
}

function ntzcrm_add_tag_form()
{ 
  include_once(NTZCRM_DIR_PATH . "includes/admin/add-tag-form.php");
}

add_action('wp_ajax_export_subscriber', 'export_subscriber');
//add_action( 'wp_ajax_nopriv_export_subscriber','export_subscriber' );
function ntzcrm_export_subscriber()
{
  include_once(NTZCRM_DIR_PATH . "includes/admin/export-subscribers.php");
  exit;
}
  
// Registration date 
/*
 * Create a column. And maybe remove some of the default ones
 * @param array $columns Array of all user table columns {column ID} => {column Name} 
 */
add_filter('manage_users_columns', 'ntzcrm_modify_user_table');

function ntzcrm_modify_user_table($columns)
{

  // unset( $columns['posts'] ); // maybe you would like to remove default columns
  $columns['registration_date'] = 'Registration date'; // add new

  return $columns;
}
function ntzcrm_add_publication_wizard(){ 
  $request=NtzCrmPostPermission::ntzcrmRequests();   
  if (isset($request['save'])) { 
    ntzcrm_dbquery::_ntzcrmSvPublications($request);
  }
  include_once(NTZCRM_DIR_PATH . "includes/admin/add-pub-wizard.php");
}
 
add_filter('manage_users_custom_column', 'ntzcrm_modify_user_table_row', 10, 3);

function ntzcrm_modify_user_table_row($row_output, $column_id_attr, $user){ 
  $date_format = 'M j, Y h:i A'; 
  switch ($column_id_attr) {
    case 'registration_date':
      return date($date_format, strtotime(get_the_author_meta('registered', $user)));
      break;
    default:
  }

  return $row_output;
} 
function ntzcrm_publications(){
  include_once(NTZCRM_DIR_PATH . "includes/admin/publications.php");
}

/*
 * Make our "Registration date" column sortable
 * @param array $columns Array of all user sortable columns {column ID} => {orderby GET-param} 
 */
add_filter('manage_users_sortable_columns', 'ntzcrm_make_registered_column_sortable');

function ntzcrm_make_registered_column_sortable($columns)
{
  return wp_parse_args(array('registration_date' => 'registered'), $columns);
}

add_action('show_user_profile', 'ntzcrm_extra_user_profile_fields');
add_action('edit_user_profile', 'ntzcrm_extra_user_profile_fields');

function ntzcrm_extra_user_profile_fields($user){ ?>
<style> 
.ntz-global-nav-menu .ntz-global-nav-menu__tab.ntz-global-nav-menu__fiv {
    background: none;
    color: #0073aa;
    border-bottom: 2px solid #0073aa
}
</style> 
<?php include_once 'ntzcrm-header.php'; ?>
<div class="ntz-wrap wrap">
  <h3>Date Registered</h3>
  <?php $userr_ID = get_current_user_id(); ?>
  <table class="form-table">
    <tr>
      <th><label for="date_reg"><?php _e("Date Registered"); ?></label></th>
      <td>
        <strong><?php echo date('M j, Y h:i A', strtotime($user->data->user_registered)); ?></strong>
      </td>
    </tr>
  </table>
 </div> 
<?php }