<?php
global $wpdb;
$table_name = $wpdb->users;
$request=NtzCrmPostPermission::ntzcrmRequests();

$orderby = (isset($request['orderby']) && in_array($request['orderby'], array_keys($this->get_sortable_columns())))?sanitize_text_field($request['orderby']): 'user_registered';

$order = (isset($request['order']) && in_array($request['order'], array('asc', 'desc'))) ? ' ' . strtoupper(sanitize_text_field($request['order'])) : ' DESC';



$DateFrom = (isset($request['datefrom']) && !empty($request['datefrom'])) ?sanitize_text_field($request['datefrom']): date("Y-m-d");
$DateTo = (isset($request['dateto']) && !empty($request['dateto'])) ?sanitize_text_field($request['dateto']): date("Y-m-d");

if ($DateFrom == $DateTo) {
  $conditions = "`user_registered` LIKE '%" . $DateFrom . "%'";
  $dateflag = "same";
} else {
  $conditions = " `user_registered` BETWEEN ' " . $DateFrom . " ' AND ' " . $DateTo . " 23:59:59'";
  $dateflag = "notsame";
}


if (isset($request['s']) && !empty($request['s'])) {
  $and = 'AND';
  $conditions .= " $and (`display_name` LIKE '%" .sanitize_text_field($request['s']). "%' OR `user_email` LIKE '%" .sanitize_text_field($request['s']). "%') GROUP BY id";
}
$geTags = ntzcrm_dbquery::_getMembershipTagsList();
 
$userTag = $wpdb->prefix . NTZCRMPRIFIX . "user_tags";
$membershipTagTabel = $wpdb->prefix . NTZCRMPRIFIX . "membership_tags";
if (isset($request['tag']) && !empty($request['tag'])) {
  $tag_id =sanitize_text_field($request['tag']);
  $conditions = "WHERE tag_id='$tag_id'";
  $sql = 'SELECT * FROM `' . $userTag . '` INNER JOIN `' . $membershipTagTabel . '` ON `' . $userTag . '`.`tag_id` = `' . $membershipTagTabel . '`.`id` INNER JOIN `' . $table_name . '` ON `' . $userTag . '`.`user_id` = `' . $table_name . '`.`ID` ' . $conditions . ' GROUP BY user_id ';
  $users = $wpdb->get_results($sql);
  if (empty($users)) {
    $users = $wpdb->get_results("SELECT ID,`umeta`.`meta_value` AS contact_id,user_login,user_email,user_registered,display_name FROM `wp_usermeta` AS umeta INNER JOIN `wp_users` AS `u` ON `umeta`.`user_id` = `u`.`ID` WHERE `user_id` IN (SELECT user_id FROM `wp_usermeta` WHERE `meta_key` = '_ntzcrm_user_tag_ids' AND `meta_value` LIKE '%" . $tag_id . "%') AND `meta_key` = '_ntzcrm_user_contact_id'  ORDER BY $orderby $order");
    $total_items = count($users);
  }
} else {
  $sql = 'SELECT * FROM `' . $userTag . '` INNER JOIN `' . $membershipTagTabel . '` ON `' . $userTag . '`.`tag_id` = `' . $membershipTagTabel . '`.`id` INNER JOIN `' . $table_name . '` ON `' . $userTag . '`.`user_id` = `' . $table_name . '`.`ID` ' . $conditions . ' GROUP BY user_id  ';
  $total_items = $wpdb->get_var('SELECT count(user_id) FROM `' . $userTag . '` INNER JOIN `' . $membershipTagTabel . '` ON `' . $userTag . '`.`tag_id` = `' . $membershipTagTabel . '`.`id` INNER JOIN `' . $table_name . '` ON `' . $userTag . '`.`user_id` = `' . $table_name . '`.`ID` ' . $conditions . ' GROUP BY user_id');
  $users = $wpdb->get_results($sql);
  if (empty($users)) {
    $users = $wpdb->get_results("SELECT * FROM $table_name WHERE $conditions ORDER BY $orderby $order");
  }
}

$delimiter = ",";
if ($dateflag == "same") {
  $filename = "subscribers_" . $DateFrom . ".csv";
} else {
  $filename = "subscribers_from_" . $DateFrom . "_to_" . $DateTo . ".csv";
}

$f = fopen('php://memory', 'w');

$fields = array('S/N', 'Name', 'Email', 'Registration date', "Contact ID", "Membership");
fputcsv($f, $fields);
foreach ($users as $count => $user) {
  $contactId = get_user_meta($user->ID, 'ntzcrm_contact_id', true);
  if (!$contactId) {
    $contactId = get_user_meta($user->ID, '_ntzcrm_user_contact_id', true);
  }

  $tagids = get_user_meta($user->ID, '_ntzcrm_user_tag_ids', true);

  $userTags = ntzcrm_dbquery::_getUserTags($user->ID);
  $tagNames = $comma = "";
  if (!empty($userTags)) { 
      $tagNames = $comma = "";
    if (!empty($tagids['ids'])) { 
      $tagNames = $comma = "";
      foreach ($userTags as $tid => $tName) {
        $tagNames .= $comma . $tid . " : " . $tName;
        $comma = "| ";
      }
    }
  }
  $lineData = array($count + 1, $user->display_name, $user->user_email, $user->user_registered, $contactId, $tagNames);
  fputcsv($f, $lineData, $delimiter);
  unset($tagNames);
  unset($contactId);
}
fseek($f, 0);
header('Content-Type: text/csv; charset=utf-8');
header('Content-Disposition: attachment; filename="' . $filename . '";');

fpassthru($f);
die;

