<?php    
class NtzCrmApi extends NtzCrmPostPermission  {
	public static function _ntzCallApi($method){  
		add_action( "wp_ajax_$method",array(__CLASS__,"$method"));
		add_action("wp_ajax_nopriv_$method",array(__CLASS__,"$method")); 
  }
  public function ntzcrm_login(){
    $status="failed"; 
    $request=self::ntzcrmRequests(); 
		try {if(!empty($request['user_login'])&&!empty($request['password'])){
					$userArr=$creds = array();
					$creds['user_login'] =strtolower(trim($request['user_login']));
					$creds['user_password'] =trim($request['password']);
					$user = wp_signon($creds,false);
					if(!is_wp_error($user)&&!empty($user)){  
            $status="success";
            $message=(!empty(get_option('ntzcrm_log_redirect_url')))?get_option('ntzcrm_log_redirect_url'):site_url("/crm-memberships-publications"); 
					}else{
						$message="Invalid email address OR Password.";
					} 
			}else{
				$message="Please enter the email OR password.";	
			}
		} catch (Exception $exc) {
			$message = $exc->getMessage();
		} 
	   self::createJson($status,$message);	
  }
  
  public static function ntzcrm_resetpassword(){
    $status="success"; 
    $request=self::ntzcrmRequests();
    try {
      if(!empty($request['email'])){
          if(!filter_var(trim($request['email']), FILTER_VALIDATE_EMAIL)){
            throw new Exception("Please enter valid email address.");
          }
          if (email_exists(trim($request["email"])) == false) {
            // throw new Exception("There is no account with that username or email address.");
            throw new Exception("Failed ! Processing Error.");
          } 
      }else{
        throw new Exception("Please enter the email."); 
      }
    } catch (Exception $exc) {
      $status="failed"; 
      $message = $exc->getMessage();
    } 
     self::createJson($status,$message);  
  }    
   
  function ntzcrm_create_user(){
    $status='success';
  
    $request=self::ntzcrmJsonRequests();
    try{  
      $tagError=$errComma=$tagNames=$comma="";
      $tagStatus=$userStatus="failed";
      $tagMessage="Tag is empty.";
      $userMessage="";
      $api_token=trim($request["api_token"]);
      $api_key=trim($request["api_key"]);
      $check=self::ntzcrmCheckToken($api_token,$api_key);
        if(!$check){
          throw new Exception("Api key or token not valid. Please contact with administrator.");
        }
        if(empty($request['person_email'])) {
          throw new Exception("Please enter the email."); 
        }

        if(email_exists($request['person_email']) == false) {
          $username=$bemail =trim($request['person_email']);
          $password =(isset($request['password'])&&!empty($request['password']))?trim($request['password']):'';
          if(empty($password)){
            throw new Exception("Password should not be blank.");
          }
          $display_name=ucfirst(trim($request['first_name'])).' '.trim($request['last_name']);
          $user_id = wp_create_user($username,$password,$bemail);
          add_user_meta($user_id,'ntzcrm_user_tag_sync',"yes");
          update_user_meta( $user_id, 'first_name', sanitize_text_field(trim($request['first_name'])));
          update_user_meta( $user_id, 'last_name', sanitize_text_field(trim($request['last_name'])));
          update_user_meta( $user_id, 'ntzcrm_contact_id', sanitize_text_field(trim($request['crm_contact_id'])));
          update_user_meta( $user_id, 'phone',sanitize_text_field(trim($request['phone']))); 
          $userMessage=$msg="User created successfully on ".NTZCRM_DOMAIN.". ";  
          if(isset($request['tag_ids'])&&!empty($request['tag_ids'])){
            $tagids=$request['tag_ids']; 
            $geTags=ntzcrm_dbquery::_getMembershipTagsList();
            foreach($tagids as $index =>$tid){  
              if(!empty($tid)&&!empty($geTags[$tid])){ 
                $tagNames .=$comma.$geTags[$tid];
                $comma =", ";
              }else{
                $tagError .=$errComma.$tid;
                $errComma=',';
                unset($tagids[$index]);
              }
            }  
            ntzcrm_dbquery::_updateUserTag($tagids,$user_id); 
            $msg .=(!empty($tagNames))?'Membership(s) successfully applied for '.$tagNames.".":'';
            $msg .=(!empty($tagError))?"Did not find membership for tag ids : ".$tagError.".":''; 
            $tagStatus=(!empty($tagError))?"failed":"success";
            if(!empty($tagError)){
              $tagMessage="Did not find membership for tag ids : ".$tagError."."; 
            }elseif(!empty($tagNames)){
              $tagMessage='Membership(s) successfully applied for '.$tagNames."."; 
            }
          }

        $userStatus="success";
        }else{
            if(isset($request["tag_ids"])&&!empty($request["tag_ids"])){
              $user = get_user_by('email',trim($request['person_email'])); 
              $userMessage=$errorMsg ="User already exists on ".NTZCRM_DOMAIN.". ";  
              $geTags=ntzcrm_dbquery::_getMembershipTagsList(); 
              $tagError=$errComma=$tagNames=$comma="";
              $tagids=$request["tag_ids"];
              foreach($tagids as $index =>$tid){  
                if(!empty($tid)&&!empty($geTags[$tid])){ 
                  $tagNames .=$comma.$geTags[$tid];
                  $comma =", ";
                }else{
                  $tagError .=$errComma.$tid;
                  $errComma=',';
                  unset($tagids[$index]);
                }
              } 
              ntzcrm_dbquery::_updateUserTag($tagids,$user->ID); 
                $errorMsg .=(!empty($tagNames))?'Membership(s) successfully applied for '.$tagNames.".":'';
                $errorMsg .=(!empty($tagError))?"Did not find membership for tag ids : ".$tagError.".":'';
                $tagStatus=(!empty($tagError))?"failed":"success";
                if(!empty($tagError)){
                  $tagMessage=$errorMsg; 
                }elseif(!empty($tagNames)){
                  $tagMessage='Membership(s) successfully applied for '.$tagNames."."; 
                } 
              throw new Exception($errorMsg);
          }else{
            $userMessage="User already exists on ".NTZCRM_DOMAIN."."; 
            throw new Exception("User already exists on ".NTZCRM_DOMAIN.".");
          } 
        } 
    }catch(Exception $e){
      $status='failed';
      $msg=$e->getMessage();
      self::sfNtzCrmMembershipErrorRequestLog($msg,$request);
    }
    $response=array('status'=>$status,'message'=>$msg,'userStatus'=>$userStatus,'userMessage'=>$userMessage,'tagStatus'=>$tagStatus,'tagMessage'=>$tagMessage);
    echo json_encode($response);
    exit;
  }

  /*
   * @params: action=ntzcrm_reset_password,api_token,api_key,person_email,password,crm_contact_id
   * @Function use: ntzcrm_reset_password: This api use to reset user password
   * @created by: Hitesh verma
   * @Created: 28-04-2020
   */
 
  public static function ntzcrm_reset_password(){
    $status='success'; 
    try{ 
      $request=self::ntzcrmJsonRequests();
      $data=array();
      $api_token=trim($request["api_token"]);
      $api_key=trim($request["api_key"]);
      $check=self::ntzcrmCheckToken($api_token,$api_key);
      if(!$check){
        throw new Exception("Api key or token not valid. Please contact with administrator.");
      }
      if(empty($request['person_email'])) {
        throw new Exception("Please enter the email."); 
      }
      
      $uemail=trim($request['person_email']);
      $ipcid=trim($request['crm_contact_id']);
      if(!empty($uemail)&&!filter_var($uemail, FILTER_VALIDATE_EMAIL)) {
        throw new Exception("Please enter valid email.");
      } 
      $user = get_user_by('email',$uemail);
      if (!$user){
        throw new Exception("User doesn`t exist on ".NTZCRM_DOMAIN.".");
      }

      $message=self::ntzcrm_generate_rp_link($user);
      if ( is_multisite() )
        $blogname = $GLOBALS['current_site']->site_name;
      else
        $blogname = wp_specialchars_decode(get_option('blogname'), ENT_QUOTES);
    $title = sprintf( __('[%s] Password Reset'), $blogname );
    $title = apply_filters('retrieve_password_title', $title); 
    if ($message && !wp_mail($uemail, $title, $message) ){
      throw new Exception("The e-mail could not be sent. Possible reason: your host may have disabled the mail() function.");
    }
    $msg="Please check you mail to reset password.";

      /*
      $uIpcid=get_user_meta($user->ID,'ntzcrm_contact_id',true);
      if(empty($uIpcid) || $uIpcid!=$ipcid){
        throw new Exception("Invalid customer ID."); 
      }

      $updateUserdata['ID']=sanitize_text_field($user->ID);
      $updateUserdata['user_pass']=trim($request['password']);
      if(wp_update_user($updateUserdata)){
        $msg=" Password reset successfully.";
      }else{
        throw new Exception("Password not changed. Please try again!");
      }
      */
    }catch(Exception $e){
      $status='failed';
      $msg=$e->getMessage();
      self::sfNtzCrmMembershipErrorRequestLog($msg,$request);
    }
    $response=array('status'=>$status,'message'=>$msg);
    echo json_encode($response);
    exit;
  }

  /*
   * @params: action=ntzcrm_generate_rp_link 
   * @Function use: ntzcrm_generate_rp_link: This use for generate email to reset password
   * @created by: Hitesh verma
   */
    
  public static  function ntzcrm_generate_rp_link($user){ 
    $userData=$user->data;
    $user_login = $userData->user_login;
    $user_email = $userData->user_email;
    $displayName = $userData->display_name;
    $key = get_password_reset_key($user);
    // $message = __('You have requested that the password be reset for the following account:') . "\r\n\r\n";
    // $message .= network_home_url( '/' ) . "\r\n\r\n";
    $userName=ucfirst($user_login);
    $resetlink=network_site_url("wp-login.php?action=rp&key=$key&login=" . rawurlencode($user_login), 'login');
    
    if(!empty(get_option('ntzcrm_resetpassword_mail_template'))){
      $message=str_replace(["#USERNAME#","#RESTPASSWORDLINK#"],[$userName,$resetlink],get_option('ntzcrm_resetpassword_mail_template'));
    }else{
      $message = sprintf(__('Username: %s'), $userName) . "\r\n";
      $message .= __('You have requested to reset password.') . "\r\n";
      $message .= __('To reset your password, visit the following address:') . "\r\n";
      $message .= $resetlink; 
    } 
    echo $message; die;   
    return $message;
  }

  /*
   * @params: action=ntzcrm_update_user_tags,api_token,api_key,uemail,tagids=55,68,22
   * @Function use: ntzcrm_update_user_tags: This use for update users purchsed tag this api hit from SF. 
   * @created by: Hitesh verma
   */
   function ntzcrm_update_user_tags(){
    $status='success'; 
    try{ 
      $tagError=$errComma=$tagNames=$comma="";
      $tagStatus="failed";
      $userStatus="";
      $userMessage="";
      $tagMessage="Tag is empty.";

      $request=self::ntzcrmJsonRequests(); 
      $data=array();
      $api_token=trim($request["api_token"]);
      $api_key=trim($request["api_key"]);
      $check=self::ntzcrmCheckToken($api_token,$api_key);
      if(!$check){
        throw new Exception("Api key or token not valid. Please contact with administrator.");
      }
      if(empty($request['person_email'])) {
        throw new Exception("Please enter the email."); 
      }
      $uemail=trim($request["person_email"]);
      if(!empty($uemail)&&!filter_var($uemail, FILTER_VALIDATE_EMAIL)) {
        throw new Exception("Please enter valid email.");
      }
      $user = get_user_by('email',$uemail);
      if (!$user){
        throw new Exception("User doesn`t exist on ".NTZCRM_DOMAIN.".");        
    }

      // $requestTags=array('3152');
      if(empty($request['tag_ids'])){
        $tagMessage="Tag is empty.";
        throw new Exception("The tag should not be blank."); 
      }
    $tagids=$request['tag_ids']; 
    $geTags=ntzcrm_dbquery::_getMembershipTagsList();
    ksort($geTags);
    $tagError=$errComma=$tagNames=$comma=""; 
    foreach($tagids as $index =>$tid){  
      if(!empty($tid)&&!empty($geTags[$tid])){ 
        $tagNames .=$comma.$geTags[$tid];
        $comma =", ";
      }else{
        $tagError .=$errComma.$tid;
        $errComma=',';
        unset($tagids[$index]);
      }
    } 
    ntzcrm_dbquery::_updateUserTag($tagids,$user->ID);  
      $msg =(!empty($tagNames))?'Membership(s) successfully applied for '.$tagNames.".":'';
      $msg .=(!empty($tagError))?"Did not find membership for tag ids : ".$tagError.".":'';
      
      $tagStatus=(!empty($tagError))?"failed":"success";
      if(!empty($tagError)){
        $tagMessage=$msg; 
      }elseif(!empty($tagNames)){
        $tagMessage='Membership(s) successfully applied for '.$tagNames."."; 
      }
    }catch(Exception $e){
      $status='failed';
      $msg=$e->getMessage();
    self::sfNtzCrmMembershipErrorRequestLog($msg,$request);
    }
    $response=array('status'=>$status,'message'=>$msg,'userStatus'=>$userStatus,'userMessage'=>$userMessage,'tagStatus'=>$tagStatus,'tagMessage'=>$tagMessage);
    echo json_encode($response);
    exit;
  } 

/*
   * @params: action=ntzcrm_update_user_tags,api_token,api_key,uemail,tagids=55,68,22
   * @Function use: ntzcrm_istag_exist: This use for update users purchsed tag this api hit from SF. 
   * @created by: Hitesh verma
   * @Created: 26-04-2020
   */
 
  public static function ntzcrm_check_user_tags(){ 
    $status='success'; 
    try{ 
      $msg="success";
      $request=self::ntzcrmJsonRequests(); 
      $data=array();
      $api_token=trim($request["api_token"]);
      $api_key=trim($request["api_key"]);
      $check=self::ntzcrmCheckToken($api_token,$api_key);
      if(!$check){
        throw new Exception("Api key or token not valid. Please contact with administrator.");
      }
      if(empty($request['person_email'])) {
        throw new Exception("Please enter the email."); 
      }
      $uemail=trim($request["person_email"]);
      if(!empty($uemail)&&!filter_var($uemail, FILTER_VALIDATE_EMAIL)) {
        throw new Exception("Please enter valid email.");
      }

      $user = get_user_by('email',$uemail); 
      if (!$user){
        throw new Exception("User doesn`t exist on ".NTZCRM_DOMAIN.".");        
      } 

      // $requestTags=array('3152');
      if(empty($request["tag_ids"])){
        throw new Exception("The tag should not be blank.");
        /*id formate 1,2,55,66,*/
      }
      $tagids=$request["tag_ids"];    
      $geTags=ntzcrm_dbquery::_getUserTags($user->ID); 

      $tagErrorArr=$tagNameArr=array();
      
      $tagError=$tagNames=$errComma=$comma=""; 
      if(!empty($tagids)){ 
      $existKey=$nonexistKey=0;
      foreach($tagids as $key =>$tid){ 
        if(isset($geTags[$tid])){  
          $tagNameArr[$existKey]['id']=$tid; 
          $existKey++; 
          $tagNames .=$comma.$geTags[$tid]; 
          $comma =", ";
        }else{
          $tagErrorArr[$nonexistKey]['id']=$tid;
          $tagError .=$errComma.$tid;
          $errComma=','; 
          $nonexistKey++;
        }
      }
        $msg =(!empty($tagNames))?"$tagNames tag id(s) exist.":'';
        $msg .=(!empty($tagError))?"$tagError tag id(s) does not exist.":'';

      $data['exist']=$tagNameArr;
      $data['notExist']=$tagErrorArr;
      }else{
        $msg =(!empty($tagError))?"$tagids tag id(s) does not exist.":'';
        $data['exist']=array();
        $data['notExist']=(!empty($tagids))?explode(",",$tagids):array();
      }
    }catch(Exception $e){
      $status='failed';
      $msg=$e->getMessage();
      self::sfNtzCrmMembershipErrorRequestLog($msg,$request);
    }
    $response=array('status'=>$status,'message'=>$msg,"data"=>$data);
    echo json_encode($response);
    exit;
  }
/*
 * @params: action=ntzcrm_remove_user_tags,api_token,api_key,uemail,tagids=55,68,22
 * @Function use: ntzcrm_remove_user_tags: This use for update users purchsed tag this api hit from SF. 
 * @created by: Hitesh verma
 * @Created: 18-04-2020
 */
 
  public static function ntzcrm_remove_user_tags(){
    $status='success';  
    try{
      $request=self::ntzcrmJsonRequests();  
      $api_token=trim($request["api_token"]);
      $api_key=trim($request["api_key"]);
      $check=self::ntzcrmCheckToken($api_token,$api_key);
      if(!$check){
        throw new Exception("Api key or token not valid. Please contact with administrator.");
      }
      if(empty($request['person_email'])) {
        throw new Exception("Please enter the email."); 
      }
      $uemail=trim($request["person_email"]);
      if(!empty($uemail)&&!filter_var($uemail, FILTER_VALIDATE_EMAIL)) {
        throw new Exception("Please enter valid email.");
      }

      $user = get_user_by('email',$uemail);
      if (!$user){
        throw new Exception("User doesn`t exist on ".NTZCRM_DOMAIN.".");        
    }
      if(empty($request["tag_ids"])){
        throw new Exception("Please tag ids should not be blank.");
        /*id formate 1,2,55,66,*/
      }
      $requestTags=$request["tag_ids"];
      
      ntzcrm_dbquery::_removeUserTag($requestTags,$user->ID); 
      
      $msg=($requestTags=='all')?"All tags are removed successfully.":"Tag(s) are removed successfully.";
    }catch(Exception $e){
      $status='failed';
      $msg=$e->getMessage();
      self::sfNtzCrmMembershipErrorRequestLog($msg,$request);
    }
    $response=array('status'=>$status,'message'=>$msg);
    echo json_encode($response);
    exit;
  }

  public static function ntzcrm_add_tag(){
    $msg=$status='success';
    $requestJson=""; 
    try{ 
        $request=self::ntzcrmRequests();
        if(!isset($request['submit'])){
          $request=self::ntzcrmJsonRequests();

          $api_token=trim($request["api_token"]);
          $api_key=trim($request["api_key"]);
          $check=self::ntzcrmCheckToken($api_token,$api_key);
        
          $request['Id']=$request["tag_id"];
          $request['CategoryId']="0";
          $request['TagName']=$request['TagName'];

          if(!$check){
            throw new Exception("Api key or token not valid. Please contact with administrator.");
          }
        } 

        ntzcrm_dbquery::_insertTag($request);
        if(isset($request['submit'])){
          wp_redirect(admin_url('/admin.php?page=add-new-tag&clearcache='.rand(1,100)));
        }
        $msg="Tag successfully added.";

      }catch(Exception $e){
        $status='failed';
        $msg=$e->getMessage();
        self::sfNtzCrmMembershipErrorRequestLog($msg,$requestJson);
      }
      $response=array('status'=>$status,'message'=>$msg);
      echo json_encode($response);
      exit;
  }
 

/*Add and remove tag functioality */  
  function ntzcrm_sanity_users(){
    $msg=$status='success';
    $data=array(); 
    try{ 
        $request=self::ntzcrmJsonRequests(); 
        $api_token=trim($request["api_token"]);
        $api_key=trim($request["api_key"]);
        $check=self::ntzcrmCheckToken($api_token,$api_key);
        if(!$check){
          throw new Exception("Api key or token not valid. Please contact with administrator.");
        }
        global $wpdb;
        $results=$wpdb->get_results("SELECT ID,user_login,user_email,display_name FROM $wpdb->users WHERE `user_login`!=`user_email`");
        if(!empty($results)){
          foreach ($results as $key => $result) {
            $data[$key]['id']=$result->ID;
            $data[$key]['user_login']=$result->user_login;
            $data[$key]['user_email']=$result->user_email;
            $data[$key]['display_name']=$result->display_name;
          }
        }

      }catch(Exception $e){
        $status='failed';
        $msg=$e->getMessage();
        self::sfNtzCrmMembershipErrorRequestLog($msg,$request);
      }
      $response=array('status'=>$status,'message'=>$msg,'data'=>$data);
      echo json_encode($response);
      exit;
  }

/*
   * @params: action=ntzcrm_check_black_listed_emails,api_token,api_key,uemail
   * @Function use: This use for wheter the email already exists or not?
   * @created by: Sheetal Rathore
   * @Created: 31-7-2020
   */
  
  function ntzcrm_check_black_listed_emails(){ 
    $status='success';
    try{ 
      $msg="success"; 
      $data=array();
      $request=self::ntzcrmJsonRequests();
      $api_token=sanitize_text_field(trim($request['api_token']));
      $api_key=sanitize_text_field(trim($request['api_key']));
      $check=self::ntzcrmCheckToken($api_token,$api_key);
      if(!$check){
        throw new Exception("Api key or token not valid. Please contact with administrator.");
      }
      if(empty($request['person_email'])) {
        throw new Exception("Please enter the email."); 
      }

      $uemail=sanitize_text_field(trim($request['person_email']));
      if(!empty($uemail)&&!filter_var($uemail, FILTER_VALIDATE_EMAIL)) {
        throw new Exception("Please enter valid email.");
      }


      global $wpdb;
      $table_name = $wpdb->users; 
      $count=$wpdb->get_var("SELECT count(ID) FROM $wpdb->users WHERE `user_email`= '".$uemail."'");
      $data['is_exist']=($count==1)?"yes":"no";
    }catch(Exception $e){
      $status='failed';
      $msg=$e->getMessage();
      self::sfNtzCrmMembershipErrorRequestLog($msg,$request);
    }
    $response=array('status'=>$status,'message'=>$msg,"data"=>$data);
    echo json_encode($response);
    exit;
  }

  public static function export_tag(){
     $tags=ntzcrm_dbquery::_getMembershipTagsList();   
     $delimiter = ",";
     $filename = "tags.csv";
     $f = fopen('php://memory', 'w');
     $fields = array('S/N','Tag Id',' Tag Name'); 
     fputcsv($f,$fields);
     $count=0; 
     foreach ($tags as $tagId => $tagName) {
        $lineData = array($count+1,$tagId,$tagName); 
        fputcsv($f, $lineData, $delimiter);
        $count++;
     }
     fseek($f,0);
     header('Content-Type: text/csv; charset=utf-8');
     header('Content-Disposition: attachment; filename="' . $filename . '";');
     fpassthru($f);
     exit;
  }

   /*
   * @params: action=ntzcrm_create_users_and_apply_tags,api_token,api_key,person_email,firstname,lastname,id,phone
   * @Function use: ntzcrm_create_users_and_apply_tags: This api use to create salesforce user in bulk 
   * @created by: Hitesh verma
   * @Created: 20-04-2020
   */
    
  public static function ntzcrm_create_users_and_apply_tags(){
    $status='success'; 
      $request=self::ntzcrmJsonRequests();
      $response=[]; 
      $tagError=$errComma=$tagNames=$comma="";
      $tagStatus=$userStatus="failed";
      $tagMessage="";
      $userMessage="";
      $api_token=trim($request["api_token"]);
      $api_key=trim($request["api_key"]);
      $check=self::ntzcrmCheckToken($api_token,$api_key);
        if(!$check){
          throw new Exception("Api key or token not valid. Please contact with administrator.");
        } 
        if(!empty($request['data'])){
          foreach ($request['data'] as $key => $reqData) {
              try{
                $geTags=ntzcrm_dbquery::_getMembershipTagsList();   
                if(empty($reqData['person_email'])) {
                  throw new Exception("Please enter the email."); 
                }
                if(email_exists($reqData['person_email'])==false) {
                  $username=$bemail = trim($reqData['person_email']);
                  $password =(isset($reqData['password'])&&!empty($reqData['password']))?trim($reqData['password']):'';
                  if(empty($password)){
                    throw new Exception("Password should not be blank.");
                  }
                  $display_name=ucfirst(trim($reqData['first_name'])).' '.trim($reqData['last_name']);
                  $user_id = wp_create_user($username,$password,$bemail);
                  add_user_meta($user_id,'ntzcrm_user_tag_sync',"yes");
                  update_user_meta($user_id, 'first_name', sanitize_text_field(trim($reqData['first_name'])));
                  update_user_meta($user_id, 'last_name', sanitize_text_field(trim($reqData['last_name'])));
                  update_user_meta($user_id, 'ntzcrm_contact_id',sanitize_text_field(trim($reqData['crm_contact_id'])));
                  update_user_meta($user_id, 'phone',sanitize_text_field(trim($reqData['phone'])));
                  $userMessage=$msg="User created successfully on ".NTZCRM_DOMAIN.". "; 
                  if(isset($reqData['tag_ids'])&&!empty($reqData['tag_ids'])){
                    $tagids=$reqData['tag_ids'];  
                    
                    $tagError=$errComma=$tagNames=$comma=""; 
                    foreach($tagids as $index =>$tid){  
                      if(!empty($tid)&&!empty($geTags[$tid])){ 
                        $tagNames .=$comma.$geTags[$tid];
                        $comma =", ";
                      }else{
                        $tagError .=$errComma.$tid;
                        $errComma=',';
                        unset($tagids[$index]);
                      }
                    } 
                    ntzcrm_dbquery::_updateUserTag($tagids,$user_id);  
                    $msg .=(!empty($tagNames))?'Membership(s) successfully applied for '.$tagNames.".":'';
                    $msg .=(!empty($tagError))?"Did not find membership for tag ids : ".$tagError.".":''; 
                    $tagStatus=(!empty($tagError))?"failed":"success";
                    if(!empty($tagError)){
                      $tagMessage="Did not find membership for tag ids : ".$tagError."."; 
                    }elseif(!empty($tagNames)){
                      $tagMessage='Membership(s) successfully applied for '.$tagNames."."; 
                    }
                  }else{
                    $tagMessage="Tag is empty.";
                  } 
                $userStatus="success";
                }else{
                  if(isset($reqData['tag_ids'])&&!empty($reqData['tag_ids'])){
                    $user = get_user_by('email',$reqData['person_email']);
                    $userMessage=$errorMsg ="User already exists on ".NTZCRM_DOMAIN.". "; 
                    if(isset($reqData['tag_ids'])&&!empty($reqData['tag_ids'])){
                      $tagids=$reqData['tag_ids']; 
                      foreach($tagids as $index =>$tid){  
                        if(!empty($tid)&&!empty($geTags[$tid])){ 
                          $tagNames .=$comma.$geTags[$tid];
                          $comma =", ";
                        }else{
                          $tagError .=$errComma.$tid;
                          $errComma=',';
                          unset($tagids[$index]);
                        }
                      } 
                        ntzcrm_dbquery::_updateUserTag($tagids,$user->ID); 
                        $errorMsg .=(!empty($tagNames))?'Membership(s) successfully applied for '.$tagNames.".":'';
                        $errorMsg .=(!empty($tagError))?"Did not find membership for tag ids : ".$tagError.".":'';
                        $tagStatus=(!empty($tagError))?"failed":"success";
                      if(!empty($tagError)){
                          $tagMessage=$errorMsg; 
                      }elseif(!empty($tagNames)){
                          $tagMessage='Membership(s) successfully applied for '.$tagNames."."; 
                      }
                      } 
                    throw new Exception($errorMsg);
                  }else{ 
                    $tagMessage="Tag is empty.";
                    $userMessage="User already exists on ".NTZCRM_DOMAIN."."; 
                    throw new Exception("User already exists on ".NTZCRM_DOMAIN.".");
                  } 
                }
              }catch(Exception $e){
              $status='failed';
              $msg=$e->getMessage();
              self::sfNtzCrmMembershipErrorRequestLog($msg,$request);
            }
            $response[]=array('status'=>$status,'message'=>$msg,'person_email'=>$reqData['person_email'],'userStatus'=>$userStatus,'userMessage'=>$userMessage,'tagStatus'=>$tagStatus,'tagMessage'=>$tagMessage);   
          }
        } 
      echo json_encode($response);
      exit;
    } 

    public static function ntzcrm_get_users(){
      $status="failed"; 
      $response=[];
      try {
        $request=self::ntzcrmRequests();
        if(isset($request["term"])&!empty($request["term"])){
          $term=trim($request["term"]);
          $term=str_replace(" ","+",$term);
          $result=ntzcrm_dbquery::_getSubscribers($term); 
          if($result){   
            $count=0;
            foreach ($result as $id =>$value) {
              $response[$count]["id"]=$id;
              $response[$count]["label"]=$value;
              $response[$count]["value"]=$value;
              $count++;
            }
            echo json_encode($response);
            die;
          }  
        }else{
          $message="Recird not found."; 
        }
      } catch (Exception $exc) {
        $message = $exc->getMessage();
        echo $message;
        die;
      }  
    } 
    
    
    /*Publication Wizard*/
    public static function ntzcrm_add_new_tag(){
      $status='success'; 
    try{   
       $request=self::ntzcrmRequests();
        if(isset($request['tag_name'])&&!empty($request['tag_name'])){
          $tag['TagName']=wp_strip_all_tags(sanitize_text_field($request['tag_name']));
          ntzcrm_dbquery::_insertTag($tag); 
        }
        $msg="Tag successfully added.";
      }catch(Exception $e){
        $status='failed';
        $msg=$e->getMessage(); 
      }
      $response=array('status'=>$status,'message'=>$msg);
      echo json_encode($response);
      exit;
    }


    public static function get_membership_tags(){
      $message=$status='success'; 
      try{  
        $request=self::ntzcrmJsonRequests();
        $tagError=$errComma=$tagNames=$comma="";
        $tagStatus=$userStatus="failed";  
        $api_token=trim($request["api_token"]);
        $api_key=trim($request["api_key"]);
        $check=self::ntzcrmCheckToken($api_token,$api_key);

        if(!$check){
          throw new Exception("Api key or token not valid. Please contact with administrator.");
        }

        $tags=ntzcrm_dbquery::_getMembershipTagsList();    
          if(empty($tags)){
            throw new Exception("Api key or token not valid. Please contact with administrator.");
          } 
      }catch(Exception $e){
        $status='failed';
        $message=$e->getMessage(); 
      } 
      self::createJson($status,$message,$tags); 
    }
    
    public static function ntzcrm_get_user_tags(){ 
      $status='success'; 
      $request=self::ntzcrmJsonRequests();
      try{ 
        $message="success";
        
        $data=array();
        $api_token=trim($request["api_token"]);
        $api_key=trim($request["api_key"]);
        $check=self::ntzcrmCheckToken($api_token,$api_key);
        if(!$check){
          throw new Exception("Api key or token not valid. Please contact with administrator.");
        }
        
        $uemail=trim($request["person_email"]);
        if(!empty($uemail)&&!filter_var($uemail, FILTER_VALIDATE_EMAIL)) {
          throw new Exception("Please enter valid email.");
        }

        $user = get_user_by('email',$uemail); 
        if (!$user){
          throw new Exception("User doesn`t exist on ".NTZCRM_DOMAIN.".");        
        } 
  
        $tagids=$request["tag_ids"];    
        $tags=ntzcrm_dbquery::_getUserTags($user->ID); 
        if (empty($tags)){
          throw new Exception("Membership Tags not found for this user.");        
        }

      }catch(Exception $e){
        $status='failed';
        $msg=$e->getMessage();
        self::sfNtzCrmMembershipErrorRequestLog($msg,$request);
      } 
      self::createJson($status,$message,$tags); 
    }
  }