<?php
/*Create tables in database during pluin activation*/
function ntzcrm_installer(){ 
    global $wpdb;
	   $sql1 ="CREATE TABLE IF NOT EXISTS `".$wpdb->prefix.NTZCRMPRIFIX."membership_tags` (
			`id` int(11) NOT NULL AUTO_INCREMENT,
			`name` varchar(255) NOT NULL, 
			`category_id` int(11) NULL,
			`status` TINYINT(2) NOT NULL DEFAULT '1',
			`created` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP,
			`modified` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP,
			PRIMARY KEY (`id`)
			) ENGINE=MyISAM DEFAULT CHARSET=latin1 AUTO_INCREMENT=1;";
		
		$sql2 = "CREATE TABLE IF NOT EXISTS `".$wpdb->prefix.NTZCRMPRIFIX."user_tags` (
			`id` int(11) NOT NULL AUTO_INCREMENT,
			`user_id` int(11) NOT NULL,
			`tag_id` int(11) NOT NULL,
			`created` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP,
			PRIMARY KEY (`id`)
			) ENGINE=MyISAM DEFAULT CHARSET=latin1 AUTO_INCREMENT=1;";

	   $sql3 ="CREATE TABLE IF NOT EXISTS `".$wpdb->prefix.NTZCRMPRIFIX."post_tags` (
			`id` int(11) NOT NULL AUTO_INCREMENT,
			`post_id` int(11) NOT NULL,
			`tag_id` int(11) NOT NULL,
			`created` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP,
			PRIMARY KEY (`id`)
			) ENGINE=MyISAM DEFAULT CHARSET=latin1 AUTO_INCREMENT=1;";

		$sql4 ="CREATE TABLE IF NOT EXISTS `".$wpdb->prefix.NTZCRMPRIFIX."user_logs` (
			`id` int(11) NOT NULL AUTO_INCREMENT,
			`user_id` int(11) NOT NULL, 
			`login` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP,
			`logout` datetime DEFAULT NULL,
			PRIMARY KEY (`id`)
			) ENGINE=MyISAM DEFAULT CHARSET=latin1 AUTO_INCREMENT=1;";
			
		$sql5 ="CREATE TABLE IF NOT EXISTS `".$wpdb->prefix.NTZCRMPRIFIX."user_activites` (
			`id` int(11) NOT NULL AUTO_INCREMENT,
			`user_id` int(11) NOT NULL,
			`post_id` int(11) NOT NULL,
			`view_count` int(11) NOT NULL DEFAULT '0',
			`modified` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP,
			`created` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP,
			PRIMARY KEY (`id`)
			) ENGINE=MyISAM DEFAULT CHARSET=latin1 AUTO_INCREMENT=1;";

		$sql6 ="CREATE TABLE IF NOT EXISTS `".$wpdb->prefix.NTZCRMPRIFIX."temp_tags` (
			`id` int(11) NOT NULL AUTO_INCREMENT,
			`tag_id` int(11) NOT NULL,
			`user_tags` TEXT NULL DEFAULT NULL,
			`post_tags` TEXT NULL DEFAULT NULL, 
			`modified` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP,
			`created` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP,
			PRIMARY KEY (`id`)
			) ENGINE=MyISAM DEFAULT CHARSET=latin1 AUTO_INCREMENT=1;";	
    require_once( ABSPATH . '/wp-admin/includes/upgrade.php' );
    dbDelta($sql1);
    dbDelta($sql2);
    dbDelta($sql3);
    dbDelta($sql4);
    dbDelta($sql5);
    dbDelta($sql6);
	// add option is plugin activate or not 
	ntzcrm_add_option();
	ntzcrm_pages();
	ntzcrm_media(NTZCRM_PLUGIN_URL . 'images/pub-access-disabled.png');
	ntzcrm_media(NTZCRM_PLUGIN_URL . 'images/pub-access-enabled.png');
	
}

function ntzcrm_pages(){
	$pages=array( 
		array('post_title'    => 'CRM Memberships - Login',
		  'post_content'  => '['.NTZCRMPRIFIX.'login]',
		  'post_status'   => 'publish',
		  'post_type'     => 'page',
		),array('post_title'    => 'CRM Memberships - Publications',
		  'post_content'  => '['.NTZCRMPRIFIX.'publications]',
		  'post_status'   => 'publish',
		  'post_type'     => 'page',
		)
	);
	foreach ($pages as $key =>$page){ 
		if(!post_exists($page['post_title'])){
			$postId=wp_insert_post($page);   
		}
	} 
}

function ntzcrm_media($imageUrl){
	global $wpdb;
	try{
	
		// $filename = '/path/to/uploads/2013/03/filename.jpg';
		$filename = basename( $imageUrl );
		
		

    	$checkAttachment = $wpdb->get_row( "SELECT count(ID) AS `count` FROM $wpdb->posts WHERE post_title = '$filename' AND post_type = 'attachment' ");
 
		if(empty($checkAttachment->count) || $checkAttachment->count==0){ 	 
			$upload_file = wp_upload_bits( $filename, null, file_get_contents( $imageUrl ) );
			if ( ! $upload_file['error'] ) {
				// Check the type of file. We'll use this as the 'post_mime_type'.
				$filetype = wp_check_filetype( basename( $filename ), null );

				// Get the path to the upload directory.
				$wp_upload_dir = wp_upload_dir();

				// Prepare an array of post data for the attachment.
				$attachment = array(
						'guid' => $wp_upload_dir['url'] . '/' . basename( $filename ),
						'post_title' => sanitize_text_field( basename( $filename )),
						'post_excerpt' => sanitize_text_field( basename( $filename ) . ' sample icon' ),
						'post_content' => sanitize_text_field( basename( $filename ) . ' sample icon' ),
						'post_mime_type' => $filetype['type'],
						'post_status'    => 'inherit',
				);

				// Insert the attachment.
				$attach_id = wp_insert_attachment( $attachment, $upload_file['file'], 0 );

				if( ! is_wp_error( $attach_id ) ) {
				
					// Make sure that this file is included, as wp_generate_attachment_metadata() depends on it.
					require_once( ABSPATH . 'wp-admin/includes/image.php' );
					require_once( ABSPATH . 'wp-admin/includes/media.php' );
					
					// Generate the metadata for the attachment, and update the database record.
					$attach_data = wp_generate_attachment_metadata( $attach_id, $upload_file['file'] );
					wp_update_attachment_metadata( $attach_id, $attach_data );
					
				}
			}
		}

	}
	catch(Exception $ex) {
		// ignore 
	}

}

function ntzcrm_add_option(){
	if ( get_option('is_actived_ntzcrm')!== false ) {
		update_option('is_actived_ntzcrm','1');
	}else {
		add_option('is_actived_ntzcrm','1',null,'no');
	}
	if (!get_option('ntzcrm_resetpassword_mail_template')) { 
		$val="Username: #USERNAME# \r\n
		You have requested to reset your password. \r\n
		To reset your password, visit the following address:\r\n
		#RESTPASSWORDLINK#";
		add_option('ntzcrm_resetpassword_mail_template',$val,null,'no');
	}
}


function ntzcrm_deactivation(){ 
 	// add option is plugin activate or not 
	update_option('is_actived_ntzcrm','0');
}
